import { ScriptFilterItem } from "./interface";
export declare class WorkflowUpdater {
    private readonly remoteInfoListURL;
    private readonly remoteWorkflowURL;
    private readonly localVersion;
    latestVersion: string;
    shouldUpdate: boolean;
    private readonly autoOpen;
    constructor(remoteInfoListURL: string, remoteWorkflowURL: string, localVersion: string, autoOpen?: boolean);
    /**
     * 检查远程与本地版本差异
     */
    checkVersion(): Promise<void>;
    /**
     * 下载并安装workflow
     * @param targetDir
     * @return {Promise<boolean>}
     */
    download(targetDir?: string): Promise<boolean>;
    /**
     * 创建升级项-结果行
     * @return {{subtitle: string, arg: string, icon: {path: string}, title: string}}
     */
    createUpdateScriptFilterItem(): ScriptFilterItem | undefined;
}
